#define UNICODE
#define _UNICODE
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <tlhelp32.h>
#include <tchar.h>
#pragma comment(linker, "/subsystem:windows,5.0 /defaultlib:kernel32.lib /defaultlib:user32.lib")

#define GUID_ALLGDIPLUSPLUS		_T("{FD21E0BB-24FB-41d4-8DB0-081D2E4DF0EC}")

void WINAPI UnloadALL();

int WINAPI _tWinMain(HINSTANCE, HINSTANCE, LPTSTR lpCmdLine, int)
{
	HANDLE hEvent = OpenEvent(EVENT_MODIFY_STATE, FALSE, GUID_ALLGDIPLUSPLUS);
	if(hEvent) {
		//풓ς
		if(MessageBox(NULL, _T("I܂?"), _T("GDI++"), MB_YESNO | MB_ICONQUESTION) == IDYES) {
			SetEvent(hEvent);
			if(MessageBox(NULL, _T("łɑSĂGDI++.DLLA[h܂?"), _T("GDI++"), MB_YESNO | MB_ICONQUESTION) == IDYES) {
				UnloadALL();
				RedrawWindow(GetDesktopWindow(), NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_ALLCHILDREN);
			}
			return 0;
		}
		CloseHandle(hEvent);
	}

	HINSTANCE hinstDLL = LoadLibrary(_T("GDI++.DLL"));
	HOOKPROC pfn = (HOOKPROC)GetProcAddress(hinstDLL, "GetMsgProc");
	if(!hinstDLL || !pfn)
		return MessageBox(NULL, _T("GDI++.DLL[hł܂"), NULL, MB_ICONHAND), 1;

	HHOOK hhk = SetWindowsHookEx(WH_GETMESSAGE, pfn, hinstDLL, 0);
	if(!hhk)
		return MessageBox(NULL, _T("tbNɎs܂"), NULL, MB_ICONHAND), 2;

	PostMessage(HWND_BROADCAST, WM_NULL, 0, 0);
	RedrawWindow(GetDesktopWindow(), NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_ALLCHILDREN);

	if(lstrcmpi(lpCmdLine, _T("-p")) == 0) {
		hEvent = CreateEvent(NULL, TRUE, FALSE, GUID_ALLGDIPLUSPLUS);
		if(hEvent)
			WaitForSingleObject(hEvent, INFINITE);
	}
	UnhookWindowsHookEx(hhk);
	return 0;
}

BOOL _RemoteFreeLibrary(DWORD dwProcessId, HMODULE hModule, BOOL bForceUnload = FALSE)
{
	HANDLE hProcess = OpenProcess(PROCESS_CREATE_THREAD | PROCESS_QUERY_INFORMATION |
									PROCESS_VM_OPERATION | PROCESS_VM_WRITE | PROCESS_VM_READ,
									TRUE, dwProcessId);
	if (!hProcess)
		return FALSE;

	DWORD ret = 0;
	DWORD dwThreadId;
	HANDLE hThread;
	
	for (;;) {
		hThread = CreateRemoteThread(hProcess, NULL, 0,
									(LPTHREAD_START_ROUTINE)FreeLibrary,
									hModule, 0, &dwThreadId);

		if(!hThread) {
			ret = FALSE;
			break;
		}

		WaitForSingleObject(hThread, INFINITE);
		GetExitCodeThread(hThread, &ret);
		CloseHandle(hThread);

		if(!bForceUnload)
			break;
		if(!ret) {
			ret = TRUE;
			break;
		}
	}

	CloseHandle(hProcess);
	return ret;
}

void WINAPI UnloadALL()
{
	HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	if(hSnapshot == INVALID_HANDLE_VALUE)
		return;

	DWORD dwMyProcessId = GetCurrentProcessId();
	PROCESSENTRY32 pe = { sizeof(PROCESSENTRY32) };
	BOOL ret = Process32First(hSnapshot, &pe);

	while(ret && GetLastError() != ERROR_NO_MORE_FILES) {
		if(pe.th32ProcessID != dwMyProcessId) {
			HANDLE hSnapModule = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, pe.th32ProcessID);
			if(hSnapModule != INVALID_HANDLE_VALUE) {
				MODULEENTRY32 me = { sizeof(MODULEENTRY32) };
				ret = Module32First(hSnapModule, &me);
				while(ret && GetLastError() != ERROR_NO_MORE_FILES) {
//					MessageBox(NULL, me.szExePath, me.szModule, MB_OK);
					if(lstrcmpi(me.szModule, _T("gdi++.dll")) == 0) {
						_RemoteFreeLibrary(pe.th32ProcessID, me.hModule, TRUE);
					}
					SetLastError(0);
					ret = Module32Next(hSnapModule, &me);
				}
				CloseHandle(hSnapModule);
			}
		}
		SetLastError(0);
		ret = Process32Next(hSnapshot, &pe);
	}
	CloseHandle(hSnapshot);
}
